#include <stdio.h>
#include <stdlib.h>
//#include <time.h>
#include <unistd.h>
#include "circle.h"
#include "io.h"
#include "request.h"
#include "routine.h"
#include "flag.h"
#include "speak.h"
#include "uss.h"
#include "timer.h"
#include "timer2.h"

static run_state_t run_state;
int speed, dist, dist_tmp, dist_trash;
static int rotate_to_circle();
static int io_sw_detection();
static int ret, angle_ref;
static int ratio, cir_x, cir_y;

int routine_search(){

	static const int speed_str = 20; // 30; // 直進速度 [cm/s]
	static const int speed_rot = 30; // 回転速度 [deg/s]

	const int dist_long = 100;
	const int dist_short = 15;
	const double bat = 5.0;

	const double dist_rot = -90;

	const int delay = 1000;

	int sw_det, uss_det;
	double volt;

	int us_f, us_b, us_l, us_r;
	
	int dist_state = 1;

	int dist_tmp_total = 0;
	int dist_trash_total = 0;

	const int ratio_ref =  3;

	int count = 0;

	while(1){

		if( quit_flag == 1) return 0;
		//if( state == 0 ) return 0;
		request_get_batt(&volt);
		if(volt <= 2.5){
			printf("非常停止スイッチが押されました\n");
			//system(line_emergency);
			battery_flag = 1;
			return 0;
		}else if(volt <= bat){
			printf("バッテリーが少ないです\n");
			//system(line_emergency);
			battery_flag = 2;
			return 0;	
		}	

		printf("\n 探索ルーチン開始\n");
		count ++;
		
		cir_dir = 0;
		angle_ref = 0;

		clear_run_flag();
		ret = 0;
		while (1) {
			switch (dist_state) {
	 			case 1:
					/*switch (course_number) {
						case 1:
							course_number++;
							break;
						case 2:
							course_number = 1;
							break;
						case 4:
							course_number = 1;
							break;
						default:
							break;
					}*/
					printf("長辺走ってる course = %d\n",course_number);

					dist_last = dist_trash_total + dist_tmp_total;
					request_set_runmode(STR, speed_str, dist_long - dist_last);
					//printf("dist_trash_total = %d, dist_tmp_total = %d\n",dist_trash_total, dist_tmp_total);

					while (1) {
						if( quit_flag == 1) return 0;
						if (state == 0) {
							request_get_runmode(&run_state, &speed, &dist);
							dist_last = dist + dist_trash_total + dist_tmp_total;
							escape_flag = 1;
							return 0;
						}
						request_get_batt(&volt);
						printf("\rvolt =%f[V]",volt);
						if(volt <= 2.5){
							printf("非常停止スイッチが押されました\n");
							//system(line_emergency);
							battery_flag = 1;
							return 0;
						}else if(volt <=bat){
							printf("バッテリーが少ないです\n");
							//system(line_emergency);
							battery_flag = 2;
							return 0;	
						}	
							
						//printf("dist_trash_total = %d, dist_tmp_total = %d\n",dist_trash_total, dist_tmp_total);

						//printf("trash_timer = %d\n",trash_timer);
						if(trash_timer == 0){
							timer2_cancel();
							clear_trash_timer();
							//printf("\r検知中\n");
							circle_get_cg(&cir_x, &cir_y, &ratio);
						}else{
							cir_x = -1;
							cir_y = -1;
							ratio = 0;
						}

						// 角度 = 座標 * 視野角 / 画像サイズ
						//cir_dir = (cir_x - IMG_CIR_X / 2) * 60 / IMG_CIR_X;
						cir_dir = (cir_x - IMG_CIR_X / 2) * 60 / IMG_CIR_X;

						sw_det = io_sw_detection();
						if (sw_det == 1) {
							printf("前方スイッチ反応\n");
							avoid_flag = 1;
							request_get_runmode(&run_state, &speed, &dist_tmp);
							request_set_runmode(STP, 0, 0);
							sleep(1);
							routine_avoid(avoid_flag);
							dist_tmp_total += dist_tmp;
							if(dist_long - dist_tmp_total > 0){
								request_set_runmode(STR, speed_str, dist_long - dist_tmp_total);
							}else{
								request_set_runmode(STP, 0, 0);
							}
							usleep(1000*delay);
						}
						else if (sw_det == 2) {
							printf("後方スイッチ反応\n");
							avoid_flag = 2;
							request_get_runmode(&run_state, &speed, &dist_tmp);
							request_set_runmode(STP, 0, 0);
							sleep(1);
							routine_avoid(avoid_flag);
							dist_tmp_total += dist_tmp;
							if(dist_long - dist_tmp_total > 0){
								request_set_runmode(STR, speed_str, dist_long - dist_tmp_total);
							}else{
								request_set_runmode(STP, 0, 0);
							}
							usleep(1000*delay);
						}
						else {
							avoid_flag = 0;
						}
						if(battery_flag == 1){
								printf("非常停止スイッチが押されました\n");
								//system(line_emergency);
								return 0;
						}else if(battery_flag == 2){
								printf("バッテリーが少ないです\n");
								//system(line_emergency);
								battery_flag = 2;
								return 0;	
							}	

						uss_det = uss_detection(&us_f, &us_b, &us_l, &us_r);
						if (uss_det == 1) {
							printf("前方超音波反応\n");
							avoid_flag = 1;
							request_get_runmode(&run_state, &speed, &dist_tmp);
							request_set_runmode(STP, 0, 0);
							sleep(1);
							routine_avoid(avoid_flag);
							dist_tmp_total += dist_tmp;
							if(dist_long - dist_tmp_total > 0){
								request_set_runmode(STR, speed_str, dist_long - dist_tmp_total);
							}else{
								request_set_runmode(STP, 0, 0);
							}
							usleep(1000*delay);
						}
						else if (uss_det == 2) {
							printf("後方超音波反応\n");
							avoid_flag = 2;
							request_get_runmode(&run_state, &speed, &dist_tmp);
							request_set_runmode(STP, 0, 0);
							sleep(1);
							routine_avoid(avoid_flag);
							dist_tmp_total += dist_tmp;
							if(dist_long - dist_tmp_total > 0){
								request_set_runmode(STR, speed_str, dist_long - dist_tmp_total);
							}else{
								request_set_runmode(STP, 0, 0);
							}
							usleep(1000*delay);
						}
						else {
							avoid_flag = 0;
						}
						if(battery_flag == 1){
								printf("非常停止スイッチが押されました\n");
								//system(line_emergency);
								return 0;
						}else if(battery_flag == 2){
								printf("バッテリーが少ないです\n");
								//system(line_emergency);
								battery_flag = 2;
								return 0;	
							}	
			
						request_get_runmode(&run_state, &speed, &dist);
						if (run_state == STP) {	
							printf("進路変更\n");
							//dist_state = 1;
							dist_trash_total = 0;
							dist_tmp_total = 0;
							dist_last = 0;
							request_set_runmode(STP, 0, 0);
							sleep(1);
							/*if(course_number == 1){
								request_set_runmode(ROT, speed_rot, 178);*/
							//}else{
								request_set_runmode(ROT, speed_rot, -182);
							//}
							sleep(1);
							while(1){
								if( quit_flag == 1) return 0;
								request_get_runmode(&run_state, &speed, &dist);
								if(run_state == STP) {
									//sleep(1);
									break;
								}
								request_get_batt(&volt);
								if(volt <= 2.5){
									printf("非常停止スイッチが押されました\n");
									//system(line_emergency);
									battery_flag = 1;
									return 0;
								}else if(volt <= bat){
									printf("バッテリーが少ないです\n");
									//system(line_emergency);
									battery_flag = 2;
									return 0;	
								}	
							}	
							request_set_runmode(STP, 0, 0);
							sleep(2);
							switch (course_number) {
								case 1:
									course_number++;
									break;
								case 2:
									course_number = 1;
									break;
								/*case 4:
									course_number = 1;
									break;*/
								default:
									break;
							}
							break;
						}

						if (ratio > ratio_ref) {
							request_get_runmode(&run_state, &speed, &dist_trash);
							dist_trash_total += dist_trash;
							//printf("trash_total = %d\n",dist_trash);
							request_set_runmode(STP, 0, 0);
							cir_dir = (cir_x - IMG_CIR_X / 2) * 60 / IMG_CIR_X;
							sleep(1);
							rotate_to_circle();
							if(battery_flag == 1){
								printf("非常停止スイッチが押されました\n");
								//system(line_emergency);
								return 0;
							}else if(battery_flag == 2){
								printf("バッテリーが少ないです\n");
								//system(line_emergency);
								battery_flag = 2;
								return 0;	
							}	
							routine_trash_detection();
							if(battery_flag == 1){
								printf("非常停止スイッチが押されました\n");
								//system(line_emergency);
								return 0;
							}else if(battery_flag == 2){
								printf("バッテリーが少ないです\n");
								//system(line_emergency);
								battery_flag = 2;
								return 0;	
							}	
							break;
							//return 0;
						}

						usleep(1000);
					}
					break;
				case 2:
					switch (course_number) {
					case 1:
						course_number++;
						break;
					case 3:
						course_number++;
						break;
					default:
						break;
					}

					printf("短辺走ってる course = %d\n",course_number);
					
					dist_last = dist_trash_total + dist_tmp_total;
					request_set_runmode(STR, speed_str, dist_short - dist_last);
					//printf("dist_trash_total = %d, dist_tmp_total = %d\n",dist_trash_total, dist_tmp_total);

					while (1) {
						if( quit_flag == 1) return 0;
						if (state == 0) {
							request_get_runmode(&run_state, &speed, &dist);
							dist_last = dist_trash_total + dist_tmp_total;
							escape_flag = 1;
							return 0;
						}
						request_get_batt(&volt);
						if(volt <= 0){
							printf("非常停止スイッチが押されました\n");
							//system(line_emergency);
							battery_flag = 1;
							return 0;
						}

						//printf("trash_timer = %d\n",trash_timer);
						if(trash_timer == 0){
							timer2_cancel();
							clear_trash_timer();
							//printf("\r検知中\n");
							circle_get_cg(&cir_x, &cir_y, &ratio);
						}else{
							cir_x = -1;
							cir_y = -1;
							ratio = 0;
						}

						// 角度 = 座標 * 視野角 / 画像サイズ
						//cir_dir = (cir_x - IMG_CIR_X / 2) * 60 / IMG_CIR_X;
						cir_dir = (cir_x - IMG_CIR_X / 2) * 60 / IMG_CIR_X;

						sw_det = io_sw_detection();
						if (sw_det == 1) {
							printf("前方スイッチ反応\n");
							avoid_flag = 1;
							request_get_runmode(&run_state, &speed, &dist_tmp);
							request_set_runmode(STP, 0, 0);
							sleep(1);
							routine_avoid(avoid_flag);
							dist_tmp_total += dist_tmp;
							if(dist_short - dist_tmp_total > 0){
								request_set_runmode(STR, speed_str, dist_short - dist_tmp_total);
							}else{
								request_set_runmode(STP, 0, 0);
							}
							usleep(1000*delay);
						}
						else if (sw_det == 2) {
							printf("後方スイッチ反応\n");
							avoid_flag = 2;
							request_get_runmode(&run_state, &speed, &dist_tmp);
							request_set_runmode(STP, 0, 0);
							sleep(1);
							routine_avoid(avoid_flag);
							dist_tmp_total += dist_tmp;
							if(dist_short - dist_tmp_total > 0){
								request_set_runmode(STR, speed_str, dist_short - dist_tmp_total);
							}else{
								request_set_runmode(STP, 0, 0);
							}
							usleep(1000*delay);
						}
						else {
							avoid_flag = 0;
						}

						uss_det = uss_detection(&us_f, &us_b, &us_l, &us_r);
						if (uss_det == 1) {
							printf("前方超音波反応\n");
							avoid_flag = 1;
							request_get_runmode(&run_state, &speed, &dist_tmp);
							request_set_runmode(STP, 0, 0);
							sleep(1);
							routine_avoid(avoid_flag);
							dist_tmp_total += dist_tmp;
							if(dist_short - dist_tmp_total > 0){
								request_set_runmode(STR, speed_str, dist_short - dist_tmp_total);
							}else{
								request_set_runmode(STP, 0, 0);
							}
							usleep(1000*delay);
						}
						else if (uss_det == 2) {
							printf("後方超音波反応\n");
							avoid_flag = 2;
							request_get_runmode(&run_state, &speed, &dist_tmp);
							request_set_runmode(STP, 0, 0);
							sleep(1);
							routine_avoid(avoid_flag);
							dist_tmp_total += dist_tmp;
							if(dist_short - dist_tmp_total > 0){
								request_set_runmode(STR, speed_str, dist_short - dist_tmp_total);
							}else{
								request_set_runmode(STP, 0, 0);
							}
							usleep(1000*delay);
						}
						else {
							avoid_flag = 0;
						}
					
						request_get_runmode(&run_state, &speed, &dist);
						if (run_state == STP) {
							printf("進路変更\n");
							dist_state = 1;
							dist_trash_total = 0;
							dist_tmp_total = 0;
							dist_last = 0;
							request_set_runmode(STP, 0, 0);
							sleep(1);
							request_set_runmode(ROT, speed_rot, dist_rot);
							sleep(5);
							break;
						}

						if (ratio > ratio_ref) {
							request_get_runmode(&run_state, &speed, &dist_trash);
							dist_trash_total += dist_trash;
							//printf("trash_total = %d\n",dist_trash);
							request_set_runmode(STP, 0, 0);
							cir_dir = (cir_x - IMG_CIR_X / 2) * 60 / IMG_CIR_X;
							sleep(1);
							rotate_to_circle();
							usleep(100);
							request_get_batt(&volt);
							if(volt <= 0){
								printf("非常停止スイッチが押されました\n");
								//system(line_emergency);
								battery_flag = 1;
								return 0;
							}
							routine_trash_detection();
							break;
							//return 0;
						}

						usleep(1000);
					}
					break;
				default:
					break;
			}
		}
	}
	return 0;
}


int rotate_to_circle(){
	
	int speed_rot = 30;
	double volt;

	printf("前方に赤色を認識 (比率 = %d, 角度 = %d)\n", ratio, cir_dir);
	angle_ref = -cir_dir;
	request_set_runmode(ROT, speed_rot , angle_ref);
	usleep(1000);
	while(1){
		if( quit_flag == 1) return 0;

		request_get_batt(&volt);
		if(volt <= 0){
			battery_flag = 1;
			return 0;
		}

		request_get_runmode(&run_state, &speed, &dist);
		if( run_state == STP ) break;
		usleep(1000*1000);
	}
	printf("回転終了\n");
	request_set_runmode(STP, 0, 0);
	sleep(1);

	//circle_flag = 1;
	return 0;
}

int io_sw_detection(){
	int sw_1, sw_2, sw_3, sw_4, sw_5, sw_6, sw_7, sw_8;
	io_get_sw(&sw_1, &sw_2, &sw_3, &sw_4, &sw_5, &sw_6, &sw_7, &sw_8);
	if(sw_1 == 0 || sw_2 == 0 || sw_3 == 0 || sw_4 == 0 ){
		return 1;
	}

	if(sw_5 == 0 || sw_6 == 0 || sw_7 == 0 || sw_8 == 0 ){
		return 2;
	}

	return 0;
}


